; ***************************************************
; **   Diego Chaparro Gonzlez  -- 4 Informtica  **
; ***************************************************
; **   Este programa utiliza una plantilla para    **
; **   modelar jarras. Pide al usuario los litros  **
; **   de agua que contiene cada jarra, y el       **
; **   programa muestra cual es la jarra ms       **
; **   llena y la jarra menos llena 		   **
; ***************************************************

; ###############################################
; Plantilla utilizada para modelar jarras de agua
; ###############################################
(deftemplate jarra
	(slot capacidad (type INTEGER))
	(slot litros    (type INTEGER)(default 0))
)

; #############################
; Inicializa la base de hechos.
; #############################
(defrule Estado-Inicial 
	?inicial <- (initial-fact)
=>
	(assert (jarra (capacidad 10)))
	(assert (jarra (capacidad 10)))
	(assert (jarra (capacidad 10)))


)

; ###############################################
; Pide al usuario los litros que tiene cada jarra
; ###############################################
(defrule Pedir_Litros
	?jarra1 <- (jarra
			(capacidad ?capacidad1)
			(litros    ?litros1)
		   )
	?jarra2 <- (jarra
			(capacidad ?capacidad2)
			(litros    ?litros2)
		   )
	?jarra3 <- (jarra
			(capacidad ?capacidad3)
			(litros    ?litros3)
		   )
	(test (= ?litros1 0))
	(test (= ?litros2 0))
	(test (= ?litros3 0))
=>

	(printout t crlf "Tenemos 3 jarras de capacidad 10. Cuales son los litros de cada una(distintos)??") 
	(printout t crlf "Litros de la jarra1??: ")
	(modify ?jarra1 (litros = (read)))
	(printout t crlf "Litros de la jarra2??: ")
	(modify ?jarra2 (litros = (read)))
	(printout t crlf "Litros de la jarra3??: ")
	(modify ?jarra3 (litros  = (read)))

)

; #####################################
;  Halla la jarra ms llena de las tres 
; #####################################
(defrule Jarra_Mas_Llena
	(declare (salience 50))
	?jarra1 <- (jarra (capacidad ?capacidad1)(litros    ?litros1))
	?jarra2 <- (jarra (capacidad ?capacidad2)(litros    ?litros2))
	?jarra3 <- (jarra (capacidad ?capacidad3)(litros    ?litros3))
	(test (neq ?jarra1 ?jarra2))
	(test (neq ?jarra2 ?jarra3))
	
	(test (> ?litros1 ?litros2))
	(test (> ?litros1 ?litros3))
	(test (>= ?litros2 ?litros3))
=>

	(printout t "La jarra con " ?litros1 " litros es la ms llena" crlf)
)

; ######################################
; Halla la jarra menos llena de las tres
; ###################################### 

(defrule Jarra_Menos_Llena
	(declare (salience 100))
	?jarra1 <- (jarra (capacidad ?capacidad1)(litros    ?litros1))
	?jarra2 <- (jarra (capacidad ?capacidad2)(litros    ?litros2))
	?jarra3 <- (jarra (capacidad ?capacidad3)(litros    ?litros3))
	(test (neq ?jarra1 ?jarra2))
	(test (neq ?jarra2 ?jarra3))
	
	(test (< ?litros1 ?litros2))
	(test (< ?litros1 ?litros3))
	(test (> ?litros2 ?litros3))
=>

	(printout t "La jarra con " ?litros1 " litros es la menos llena" crlf)
)


