
; ***************************************************
; **   Diego Chaparro Gonzlez  -- 4 Informtica  **
; ***************************************************
; **   Este programa resuelve el problema de las   **
; **   jarras de agua mediante la bsqueda en      **
; **   profundidad.				   **
; **   Tenemos 2 jarras de agua, una de 3 litros   **
; **   y la otra de 4, y queremos que en la de 4   **
; **   litros queden exactamente 2 litros.         **
; ***************************************************


; ############################################
;   Plantilla para la construccin del rbol          
; ############################################
(deftemplate estado
	(slot litros_j3l  		; Litros que tiene la jarra de 3l
        	(type INTEGER)
                (default 0)
	)	
	(slot litros_j4l		; litros que tiene la jarra de 4l
		(type INTEGER)
		(default 0)
	)

        (slot profundidad          	; Profundidad del nodo en el arbol
                (type INTEGER)
                (default 0)
           	(range 0 ?VARIABLE)
	)

	(slot nodo			; Nmero de nodo en el rbol
        	(type INTEGER)
           	(default 0)
	)        
    
	(slot padre                	; Nodo padre
      		(type FACT-ADDRESS SYMBOL) 
      		(allowed-symbols no-padre)
	)
	
	(slot operacion            	; Descripcion del movimiento
      		(type STRING)
	)
)

; #############################
;        ESTADO INICIAL        
; #############################     
(defrule Estado-Inicial
	?inicial <- (initial-fact)
=>
	(printout t "El estado inicial es jarra3l = 0 litros y jarra4l = 0 litros" crlf)
	(assert (profundidad 0 0))       ;0 profundidad  0 nodos
	(assert (estado  
			(litros_j3l 0) 
			(litros_j4l 0) 
			(profundidad 0) 
			(padre no-padre)
			(operacion "No moviento")
		)
	)
	(assert (maxima-profundidad 7))
	(assert (nodos 1))
)


; #######################################################
;   OPERACIONES QUE SE PUEDEN REALIZAR SOBRE LAS JARRAS
; #######################################################

; ############################
; Regla para llenar la jarra3l
; ############################
(defrule Llena_Jarra3l
	(declare (salience 500))
	?estado <- (estado 
			(litros_j3l ?cantidad1)
			(litros_j4l ?cantidad2)
			(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (< ?cantidad1 3))
=>
	(assert (estado (litros_j3l 3)
			(litros_j4l ?cantidad2)
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Llena la jarra de 3l")
		)
	)
)

; ############################
; Regla para llenar la jarra4l
; ############################
(defrule Llena_Jarra4l
	(declare (salience 500))
	?estado <- (estado 
			(litros_j3l ?cantidad1)
			(litros_j4l ?cantidad2)
			(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (< ?cantidad2 4))
=>
	(assert (estado (litros_j3l ?cantidad1)
			(litros_j4l 4)
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Llena la jarra de 4l")
		)
	)
)

; ############################
; Regla para vaciar la jarra3l
; ############################
(defrule Vacia_Jarra3l
	(declare (salience 500))
	?estado <- (estado
		(litros_j3l ?cantidad1)
		(litros_j4l ?cantidad2)
		(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (> ?cantidad1 0))
=>
	(assert (estado (litros_j3l 0)
			(litros_j4l ?cantidad2)
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Vacia la jarra de 3l")
		)
	)
)

; ############################
; Regla para vaciar la jarra4l
; ############################
(defrule Vacia_Jarra4l
	(declare (salience 500))
	?estado <- (estado
		(litros_j3l ?cantidad1)
		(litros_j4l ?cantidad2)
		(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (> ?cantidad2 0))
=>
	(assert (estado (litros_j3l ?cantidad1)
			(litros_j4l 0)
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Vacia la jarra de 4l")
		)
	)
)

; ###################################################
;   Regla para echar parte del contenido de jarra3l
; en la jarra4l. No caben todos los litros de jarra3l
; ###################################################
(defrule Echar_Parte__J3l_en_J4l
	(declare (salience 500))
	?estado <- (estado
		(litros_j3l ?cantidad1)
		(litros_j4l ?cantidad2)
		(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (> ?cantidad1 (- 4 ?cantidad2)))
	(test (< ?cantidad2 4))
=>
	(assert (estado (litros_j3l (- ?cantidad1 (- 4 ?cantidad2)))
			(litros_j4l 4)
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Echar parte de J3l en J4l")
		)
	)
	
)

; ###################################################
;   Regla para echar parte del contenido de jarra4l
; en la jarra3l. No caben todos los litros de jarra4l
; ###################################################
(defrule Echar_Parte__J4l_en_J3l
	(declare (salience 500))
	?estado <- (estado
		(litros_j3l ?cantidad1)
		(litros_j4l ?cantidad2)
		(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (> ?cantidad2 (- 3 ?cantidad1)))
	(test (< ?cantidad1 3))
=>
	(assert (estado (litros_j3l 3)
			(litros_j4l (- ?cantidad2 (- 3 ?cantidad1)))
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Echar parte de J4l en J3l")
		)
	)
	
)

; #######################################################
; Regla para echar todos los litros de jarra3l en jarra4l
; #######################################################
(defrule Volcar_J3l_en_J4l
	(declare (salience 500))
	?estado <- (estado
		(litros_j3l ?cantidad1)
		(litros_j4l ?cantidad2)
		(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (<= ?cantidad1 (- 4 ?cantidad2)))
	(test (> ?cantidad1 0))
	(test (< ?cantidad2 4))
=>
	(assert (estado (litros_j3l 0)
			(litros_j4l (+ ?cantidad2 ?cantidad1))
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Volcar J3l en J4l")
		)
	)
)

; #######################################################
; Regla para echar todos los litros de jarra4l en jarra3l
; #######################################################
(defrule Volcar_J4l_en_J3l
	(declare (salience 500))
	?estado <- (estado
		(litros_j3l ?cantidad1)
		(litros_j4l ?cantidad2)
		(profundidad ?profundidad))
	(profundidad ?nivel ?)
	(test (= ?profundidad ?nivel))
	(test (<= ?cantidad2 (- 3 ?cantidad1)))
	(test (> ?cantidad2 0))
	(test (< ?cantidad1 3))
=>
	(assert (estado (litros_j3l (+ ?cantidad1 ?cantidad2))
			(litros_j4l 0)
			(profundidad (+ ?profundidad 1))
			(padre ?estado)
			(operacion "Volcar J4l en J3l")
		)
	)
)
			
; #######################################################################
; A PARTIR DE AQUI ESTAN LAS REGLAS QUE CONTROLAN LA BUSQUEDA EN AMPLITUD
; #######################################################################
		

; #########################################
;  Regla para Increntar la cuenta de nodos
; #########################################
(defrule Incrementa-cuenta-nodos
	(declare (salience 1100))
	?estado <- (estado (nodo ?estadoNodo))
	?nodos <- (nodos ?cuentaNodos)
	(test (= ?estadoNodo 0))
 =>
	(assert (nodos (+ 1 ?cuentaNodos)))
	(modify ?estado (nodo ?cuentaNodos))
	(retract ?nodos)
)

; ######################################
;  Regla para actualizar la profundidad
; ######################################
(defrule actualiza-profundidad
        (declare (salience 100))
        ?profundidad <- (profundidad ?nivel ?numNodosViejo)
        (nodos ?nodos)
        (test (> ?nodos ?numNodosViejo))
=>
        (retract ?profundidad)
        (assert (profundidad (+ 1 ?nivel) ?nodos))
)

; ########################################
;  Regla que comprueba si se alcanza meta
; ########################################
(defrule Hecho
        (declare (salience 1000))
        ?estado <- (estado 
                        (litros_j4l 2))
=>
        (assert (completa ?estado))
        (assert (lista "Hecho"))
)

; ################################################################
;  Regla para construir el camino una vez encontrada una solucion
; ################################################################
(defrule Completa
	(declare (salience 2000))
	?estado  <- (estado (padre ?padre) (operacion ?movimiento))
	?completa <- (completa ?estado)
	?lista-vieja <- (lista $?resto)
=>
	(assert (lista ?movimiento ?resto))
	(assert (completa ?padre))
	(retract ?completa)
	(retract ?lista-vieja)
)

; #################################
;  Regla para imprimir la solucion
; #################################
(defrule Camino-Completado
	(declare (salience 2000))
	?completa <- (completa no-padre)
	(nodos ?numNodos)
	?lista-vieja <- (lista ?primero $?movimientos ?ultimo)
=>
	;(printout t "Solucion:" crlf ?movimientos crlf)
	(printout t "- Solucion en el nodo " (- ?numNodos 1) ":" crlf)
	(progn$ (?m ?movimientos) (printout t ?m crlf))
	(retract ?completa ?lista-vieja)
)

; #################################################################
;  Regla para acabar cuando se alcanze cierto nivel de profundidad
; #################################################################
(defrule alcanza-maxima-profundidad
	(declare (salience 1000))
	(profundidad ?nivel ?)
	(maxima-profundidad =(+ 1 ?nivel))
	(nodos ?numNodos)
 =>
	(printout t crlf "Sobrepasado el nivel de profundidad ", ?nivel "." crlf)
	(printout t "Un total de " (- ?numNodos 1) " nodos en el arbol" crlf)
	(halt)
)

; #################################################
;  Regla para acabar cuando no se aaden mas nodos
; #################################################
(defrule FIN
	(declare (salience 100))
	?profundidad <- (profundidad ?nivel ?numNodosViejos)
	(nodos ?numNodos)
	(test (= ?numNodos ?numNodosViejos))
=>
	(printout t "Un total de " (- ?numNodos 1) " nodos en el arbol" crlf)
	(retract ?profundidad)
	(halt)
)   
