
; #####################################
;  PLANTILLA UTILIZADA PARA LAS REGLAS
; #####################################
(deftemplate regla
	(multislot SI)
	(multislot ENTONCES)
)

; ###################
; MOTOR DE INFERENCIA
; ###################

(defrule propagar-meta
	(meta es ?meta)
	(regla (SI ?variable $?)
		(ENTONCES ?meta ? ?valor))
=> 
	(assert (meta es ?variable))
)

(defrule meta-satisfecha
	(declare (salience 30))
	?m <- (meta es ?meta)
	(variable ?meta ?valor)
=>
	(retract ?m)
)

(defrule borrar-regla-que-no-equipara
	(declare (salience 20))
	(variable ?variable ?valor)
	?r<- (regla (SI ?variable ? ?un-valor $?))
	(test (neq ?valor ?un-valor))
=>
	(retract ?r)
)

(defrule modificar-regla-que-equipara
	"Reducir regla eliminando la variable que equipara"
	(declare (salience 20))
	(variable ?variable ?valor)
	?r <- (regla (SI ?variable ? ?valor Y $?Resto-antecedente))
=>
	(modify ?r (SI $?Resto-antecedente))
)

(defrule regla-satisfecha
	(declare (salience 20))
	(variable ?variable ?valor)
	?r <- (regla (SI ?variable ? ?valor)
			(ENTONCES ?meta ? ?valor-meta))
=>
	(retract ?r)
	(assert (variable ?meta ?valor-meta))
)

(defrule Hacer-pregunta
	(declare (salience 10))
	?m <- (meta es ?variable)
	?p <- (pregunta ?variable ? ?texto)
=>
	(printout t ?texto)
	(bind ?respuesta (read))
	(assert (variable ?variable ?respuesta))
)

(defrule Dar-Resultados
	(declare (salience 50))
	(variable ?meta ?valor)
	(meta es ?meta)
	(test (eq ?meta Tipo_pez))
=>
	(printout t "************* " crlf)
	(printout t "El pez es: ")
	(printout t ?valor crlf)
)


; ##############################################
;      DECLARACIN DE LOS HECHOS INICIALES
;  Se definen las reglas, y las preguntas para
;  alcanzar cada una de las metas
; ##############################################
(deffacts hechos_iniciales

	(meta es Tipo_pez)
	

	(pregunta Cola_redondeada es "Tiene la cola redondeada (si/no)??: ")
	(regla (SI Cola_redondeada es si) 						; P1
		(ENTONCES P1 es Ciclido)
	)
	(regla (SI Cola_redondeada es no)
		(ENTONCES P1 es No_ciclido)
	)


	(pregunta Tamano_medio es "Tiene tamao medio (si/no)??: ")				; P2
	(regla (SI P1 es No_ciclido Y Tamano_medio es si)
		(ENTONCES P2 es Anabatido)
	)
	(regla (SI P1 es No_ciclido Y Tamano_medio es no)
		(ENTONCES P2 es Ciprinodontiformes)
	)

	
	(pregunta Rios_mundo es "Vive en muchos rios del mundo (si/no)??: ")			; P3
	(regla (SI Rios_mundo es no)
		(ENTONCES Tipo_pez es "No existe en la BBDD")
	)
	(regla (SI P1 es Ciclido Y Rios_mundo es si)
		(ENTONCES P3 es Ciclido)
	)
	(regla (SI P2 es Anabatido Y Rios_mundo es si)	
		(ENTONCES P3 es Anabatido)
	)
	(regla (SI P2 es Ciprinodontiformes Y Rios_mundo es si)
		(ENTONCES P3 es Ciprinodontiformes)
	)
	
	
	(pregunta Boca_pequena es "Tiene la boca pequea (si/no)??: ")				; P4
	(regla (SI P3 es Ciprinodontiformes Y Boca_pequena es si)
		(ENTONCES P4 es Ciprinodontiformes)
	)
	(regla (SI P3 es Ciprinodontiformes Y Boca_pequena es no)
		(ENTONCES Tipo_pez es "No existe en la BBDD")
	)
	(regla (SI P3 es Ciclido Y Boca_pequena es si)
		(ENTONCES P4 es Ciclido)
	)
	(regla (SI P3 es Ciclido Y Boca_pequena es no)
		(ENTONCES Tipo_pez es "No existe en la BBDD")
	)
	

	(pregunta Dientes_puntiagudos es "Tiene los dientes puntiagudos (si/no)??: ")		; P5
	(regla (SI P4 es Ciprinodontiformes Y Dientes_puntiagudos es si)
		(ENTONCES P5 es Ciprinodontiformes)
	)
	(regla (SI P4 es Ciprinodontiformes Y Dientes_puntiagudos es no)
		(ENTONCES Tipo_pez es "No existe en la BBDD")
	)
	(regla (SI P3 es Anabatido Y Dientes_puntiagudos es si)
		(ENTONCES P5 es Anabatido)
	)
	(regla (SI P3 es Anabatido Y Dientes_puntiagudos es no)
		(ENTONCES Tipo_pez es "No existe en la BBDD")
	)

	
	(pregunta Canales_laberinticos es "Tiene canales labernticos (si/no)??: ")		; P6
	(regla (SI P5 es Anabatido Y Canales_laberinticos es si)
		(ENTONCES P6 es Anabatido)
	)
	(regla (SI P5 es Anabatido Y Canales_laberinticos es no)
		(ENTONCES Tipo_pez es "No existe en la BBDD")
	)


	(pregunta Rios_America_Sur es "Vive en los ros de Amrica del sur (si/no)??: ")	; P7
	(regla (SI P5 es Ciprinodontiformes Y Rios_America_Sur es si)
		(ENTONCES P7 es Poecilido)
	)
	(regla (SI P5 es Ciprinodontiformes Y Rios_America_Sur es no)
		(ENTONCES Tipo_pez es "Orden de los Ciprinodontiformes")
	)


	(pregunta Es_macho es "Es macho (si/no)??: ")						; P8
	(regla (SI P7 es Poecilido Y Es_macho es si)
		(ENTONCES P8 es Poecilido_macho)
	)
	(regla (SI P7 es Poecilido Y Es_macho es no)
		(ENTONCES P8 es Poecilido_hembra)
	)

	
	(pregunta Manchas_cuerpo es "Tiene manchas en el cuerpo (si/no)??: ")			; P11
	(regla (SI P8 es Poecilido_macho Y Manchas_cuerpo es si)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}->Gambusia Affinis(Macho con gnopodio. Hembra 3cm ms grande que el macho)")
	)
	(regla (SI P8 es Poecilido_hembra Y Manchas_cuerpo es si)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}->Gambusia Affinis(Hembra. Macho 3cm ms pequeo que la hembra)")
	)
	(regla (SI P8 es Poecilido_macho Y Manchas_cuerpo es no)
		(ENTONCES P11 es Gambusia_Punctata_macho)
	)
	(regla (SI P8 es Poecilido_hembra Y Manchas_cuerpo es no)
		(ENTONCES P11 es Gambusia_Punctata_hembra)
	)
	
	
	(pregunta Color_gris es "Es de color gris (si/no)??: ")					; P12
	(regla (SI P11 es Gambusia_Punctata_macho Y Color_gris es si)
		(ENTONCES P12 es Gambusia_Punctata_macho)
	)
	(regla (SI P11 es Gambusia_Punctata_hembra Y Color_gris es si)
		(ENTONCES P12 es Gambusia_Punctata_hembra)
	)
	(regla (SI P11 es Gambusia_Punctata_macho Y Color_gris es no)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}(Macho con gnopodio. Hembra 3cm ms grande que el macho)")
	)
	(regla (SI P11 es Gambusia_Punctata_hembra Y Color_gris es no)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}(Hembra. Macho 3cm ms pequeo que la hembra)")
	)


	(pregunta Rayas_verdes es "Tiene rayas verdes (si/no)??: ")				; P13
	(regla (SI P12 es Gambusia_Punctata_macho Y Rayas_verdes es si)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}->Gambusia Punctata(Macho con gnopodio. Hembra 3cm ms grande que el macho)")
	)
	(regla (SI P12 es Gambusia_Punctata_hembra Y Rayas_verdes es si)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}->Gambusia Punctata(Hembra. Macho 3cm ms pequeo que la hembra)")
	)
	(regla (SI P12 es Gambusia_Punctata_macho Y Rayas_verdes es no)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}(Macho con gnopodio. Hembra 3cm ms grande que el macho)")
	)	
	(regla (SI P12 es Gambusia_Punctata_hembra Y Rayas_verdes es no)
		(ENTONCES Tipo_pez es "Orden Ciprinodontiformes {Familia Poecilidos}(Hembra. Macho 3cm ms pequeo que la hembra)")
	)

	
	(pregunta Color_azul es "Es de color azul (si/no)??: ")					; P14
	(regla (SI P6 es Anabatido Y Color_azul es si)
		(ENTONCES P14 es Luchadores_sian)
	)
	(regla (SI P6 es Anabatido Y Color_azul es no)
		(ENTONCES P14 es Perca_trepadora)
	)
	

	(pregunta Rayas_rojas es "Tiene rayas rojas (si/no)??: ")				; P15
	(regla (SI P14 es Luchadores_sian Y Rayas_rojas es si)
		(ENTONCES P15 es Luchadores_sian)
	)
	(regla (SI P14 es Luchadores_sian Y Rayas_rojas es no)
		(ENTONCES Tipo_pez es "Orden Anabatidos")
	)


	(pregunta Rios_asia es "Vive en los ros de Asia (si/no)??: ")				; P16
	(regla (SI P15 es Luchadores_sian Y Rios_asia es si)
		(ENTONCES Tipo_pez es "Orden Anabatidos -> Luchadores de Sian")
	)
	(regla (SI P15 es Luchadores_sian Y Rios_asia es no)
		(ENTONCES Tipo_pez es "Orden Anabatidos")
	)

	
	(pregunta Mide_25cm es "Mide 25 centmetros (si/no)??: ")				; P17
	(regla (SI P14 es Perca_trepadora Y Mide_25cm es si)
		(ENTONCES P17 es Perca_trepadora)
	)
	(regla (SI P14 es Perca_trepadora Y Mide_25cm es no)
		(ENTONCES Tipo_pez es "Orden Anabatidos")
	)

	
	(pregunta Tiene_rayas es "Tiene rayas (si/no)??: ")					; P18
	(regla (SI P17 es Perca_trepadora Y Tiene_rayas es no)
		(ENTONCES Tipo_pez es "Orden Anabatidos -> Perca trepadora")
	)
	(regla (SI P17 es Perca_trepadora Y Tiene_rayas es si)
		(ENTONCES Tipo_pez es "Orden Anabatidos")
	)

	
	(pregunta Rios_africa es "Vive en los ros de frica (si/no)??: ")			; P19
	(regla (SI P4 es Ciclido Y Rios_africa es si)
		(ENTONCES P19 es Pez_joya)
	)
	(regla (SI P4 es Ciclido Y Rios_africa es no)
		(ENTONCES Tipo_pez es "Orden Ciclidos")
	)


	(pregunta Color_rojo es "Es de color rojo (si/no)?: ")					; P20
	(regla (SI P19 es Pez_joya Y Color_rojo es si)
		(ENTONCES P20 es Pez_joya)
	)
	(regla (SI P19 es Pez_joya Y Color_rojo es no)
		(ENTONCES Tipo_pez es "Orden Ciclidos")
	)

	
	(pregunta Manchas_negras es "Tiene manchas negras (si/no)?: ")				; P21
	(regla (SI P20 es Pez_joya Y Manchas_negras es si)
		(ENTONCES Tipo_pez es "Orden Ciclidos -> Pez Joya")
	)
	(regla (SI P20 es Pez_joya Y Manchas_negras es no)
		(ENTONCES Tipo_pez es "Orden Ciclidos")
	)
)
