
; #######################################################
;  		PLANTILLAS UTILIZADAS
; #######################################################

; De quien es el turno??. 1-> ordenador. 2-> usuario
(deftemplate turno (slot es (type INTEGER)(range 1 2)))


; Tablero. Si ficha = 0-> vaca, 1-> ordenador, 2->usuario
(deftemplate casilla
		(slot columna (type INTEGER))
		(slot fila    (type INTEGER))
		(slot ficha   (type INTEGER) (range 0 2))
)

; ########################################
; 		HECHOS INICIALES
; ########################################
(deffacts hechos_iniciales

	(turno (es 2))
	(casilla (columna 1) (fila 1) (ficha 0))
	(casilla (columna 1) (fila 2) (ficha 0))
	(casilla (columna 1) (fila 3) (ficha 0))
	(casilla (columna 1) (fila 4) (ficha 0))
	(casilla (columna 1) (fila 5) (ficha 0))
	(casilla (columna 1) (fila 6) (ficha 0))
	(casilla (columna 2) (fila 1) (ficha 0))
	(casilla (columna 2) (fila 2) (ficha 0))
	(casilla (columna 2) (fila 3) (ficha 0))
	(casilla (columna 2) (fila 4) (ficha 0))
	(casilla (columna 2) (fila 5) (ficha 0))
	(casilla (columna 2) (fila 6) (ficha 0))
	(casilla (columna 3) (fila 1) (ficha 0))
	(casilla (columna 3) (fila 2) (ficha 0))
	(casilla (columna 3) (fila 3) (ficha 0))
	(casilla (columna 3) (fila 4) (ficha 0))
	(casilla (columna 3) (fila 5) (ficha 0))
	(casilla (columna 3) (fila 6) (ficha 0))
	(casilla (columna 4) (fila 1) (ficha 0))
	(casilla (columna 4) (fila 2) (ficha 0))
	(casilla (columna 4) (fila 3) (ficha 0))
	(casilla (columna 4) (fila 4) (ficha 0))
	(casilla (columna 4) (fila 5) (ficha 0))
	(casilla (columna 4) (fila 6) (ficha 0))
	(casilla (columna 5) (fila 1) (ficha 0))
	(casilla (columna 5) (fila 2) (ficha 0))
	(casilla (columna 5) (fila 3) (ficha 0))
	(casilla (columna 5) (fila 4) (ficha 0))
	(casilla (columna 5) (fila 5) (ficha 0))
	(casilla (columna 5) (fila 6) (ficha 0))
	(casilla (columna 6) (fila 1) (ficha 0))
	(casilla (columna 6) (fila 2) (ficha 0))
	(casilla (columna 6) (fila 3) (ficha 0))
	(casilla (columna 6) (fila 4) (ficha 0))
	(casilla (columna 6) (fila 5) (ficha 0))
	(casilla (columna 6) (fila 6) (ficha 0))
	(casilla (columna 7) (fila 1) (ficha 0))
	(casilla (columna 7) (fila 2) (ficha 0))
	(casilla (columna 7) (fila 3) (ficha 0))
	(casilla (columna 7) (fila 4) (ficha 0))
	(casilla (columna 7) (fila 5) (ficha 0))
	(casilla (columna 7) (fila 6) (ficha 0))

	(leido_columna 0)	
	(columna 0)
)

(defrule Estado-Inicial
	(declare (salience 15))
	?inicial <- (initial-fact)
=>
	(assert (mostrar 1))
)


; #######################################
; *# Leemos el movimiento del usuario  ##
; #######################################
(defrule turno_usuario
	(declare (salience 10))
	(turno (es 2))
	?c <-(columna ?columna)
	?l <-(leido_columna 0)
=> 
	(retract ?c)
	(retract ?l)
	(assert (leido_columna 1))
	(printout t "Movimiento (columna): ")
	(bind ?col (read))
	(assert (columna ?col))
	
)

; ######################################
; ## Jugada invlida. Columna llena   ##
; ######################################
(defrule comprobar_jugada_invalida1
	(declare (salience 20))
	(turno (es 2))
	?l <-(leido_columna 1)
	(columna ?columna)
	(casilla (columna ?columna) (fila 6) (ficha ?ficha))
	(test (<> ?ficha 0))
=>
	(printout t "Movimiento no vlido" crlf)
	(retract ?l)
	(assert (leido_columna 0))
)

; #######################################
; ## Jugada invlida. Columna invlida ##
; #######################################
(defrule comprobar_jugada_invalida2
	(declare (salience 20))
	(turno (es 2))
	?l <-(leido_columna 1)
	(columna ?columna)
	(test (> ?columna 7))
=>
	(printout t "Movimiento no vlido" crlf)
	(retract ?l)
	(assert (leido_columna 0))
)

; #######################################
; ## Jugada invlida. Columna invlida ##
; #######################################
(defrule comprobar_jugada_invalida3
	(declare (salience 20))
	(turno (es 2))
	?l <-(leido_columna 1)
	(columna ?columna)
	(test (< ?columna 1))
=>
	(printout t "Movimiento no vlido" crlf)
	(retract ?l)
	(assert (leido_columna 0))
)


; ###########################################
; ## Comprobar jugada vlida del usuario y ##
; ## realizar el movimiento                ##
; ###########################################
(defrule comprobar_jugada_valida_1
	(declare (salience 24))
	?t <-(turno (es 2))
	?l <-(leido_columna 1)
	?c <-(columna ?columna)
	
	?cas1 <- (casilla (columna ?columna) (fila 1) (ficha 0))

	(test (<= ?columna 7))
	(test (>= ?columna 1))
=>
	

	(printout t crlf "   TU mueves a la columna " ?columna  crlf)
	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))
	
	(retract ?t) 
	(assert (turno (es 1)))

	(retract ?cas1)
	(assert (casilla (columna ?columna) (fila 1) (ficha 2)))

	;(assert (mostrar 1))
)

(defrule comprobar_jugada_valida_2
	(declare (salience 23))
	?t <-(turno (es 2))
	?l <-(leido_columna 1)
	?c <-(columna ?columna)
	
	?cas2 <- (casilla (columna ?columna) (fila 2) (ficha 0))
	
	(test (<= ?columna 7))
	(test (>= ?columna 1))
=>
	

	(printout t crlf "   TU mueves a la columna " ?columna  crlf)
	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))
	
	(retract ?t) 
	(assert (turno (es 1)))
	
	(retract ?cas2)
	(assert (casilla (columna ?columna) (fila 2) (ficha 2)))
	
	;(assert (mostrar 1))
)

(defrule comprobar_jugada_valida_3
	(declare (salience 22))
	?t <-(turno (es 2))
	?l <-(leido_columna 1)
	?c <-(columna ?columna)
	
	?cas3 <- (casilla (columna ?columna) (fila 3) (ficha 0))
	
	(test (<= ?columna 7))
	(test (>= ?columna 1))
=>
	

	(printout t crlf "   TU mueves a la columna " ?columna  crlf)
	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))
	
	(retract ?t) 
	(assert (turno (es 1)))
	
	(retract ?cas3)
	(assert (casilla (columna ?columna) (fila 3) (ficha 2)))
		
	;(assert (mostrar 1))
)

(defrule comprobar_jugada_valida_4
	(declare (salience 21))
	?t <-(turno (es 2))
	?l <-(leido_columna 1)
	?c <-(columna ?columna)
	
	?cas4 <- (casilla (columna ?columna) (fila 4) (ficha 0))
	
	(test (<= ?columna 7))
	(test (>= ?columna 1))
=>
	

	(printout t crlf "   TU mueves a la columna " ?columna  crlf)
	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))
	
	(retract ?t) 
	(assert (turno (es 1)))
	
	(retract ?cas4)
	(assert (casilla (columna ?columna) (fila 4) (ficha 2))) 
	
	;(assert (mostrar 1))
)

(defrule comprobar_jugada_valida_5
	(declare (salience 20))
	?t <-(turno (es 2))
	?l <-(leido_columna 1)
	?c <-(columna ?columna)
	
	?cas5 <- (casilla (columna ?columna) (fila 5) (ficha 0))
	
	(test (<= ?columna 7))
	(test (>= ?columna 1))
=>
	

	(printout t crlf "   TU mueves a la columna " ?columna  crlf)
	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))
	
	(retract ?t) 
	(assert (turno (es 1)))
	
	(retract ?cas5)
	(assert (casilla (columna ?columna) (fila 5) (ficha 2))) 
	
	;(assert (mostrar 1))
)

(defrule comprobar_jugada_valida_6
	(declare (salience 19))
	?t <-(turno (es 2))
	?l <-(leido_columna 1)
	?c <-(columna ?columna)
	
	?cas6 <- (casilla (columna ?columna) (fila 6) (ficha 0))
	
	(test (<= ?columna 7))
	(test (>= ?columna 1))
=>
	

	(printout t crlf "   TU mueves a la columna " ?columna  crlf)
	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))
	
	(retract ?t) 
	(assert (turno (es 1)))
	
	(retract ?cas6)
	(assert (casilla (columna ?columna) (fila 6) (ficha 2)))

	;(assert (mostrar 1))
)
; ########################################################################################################+
; #################################  MOVIMIENTOS MAQUINA #################################################
; ########################################################################################################


; ################################################################################
; ##            EVITAR MOVIMIENTOS DEL USUARIO 					##
; ################################################################################

; ######################################################
; ## Evita 4 en raya del usuario horizontal aadiendo ##
; ## una ficha en la izquierda en la fila 1           ##
; ######################################################

(defrule evitar_4enraya_horizontal_usuario_izq_fila1
	

	(declare (salience 42))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila 1) (ficha 0))
	(casilla (columna ?columna1) (fila 1) (ficha 2))
	(casilla (columna ?columna2) (fila 1) (ficha 2))
	(casilla (columna ?columna3) (fila 1) (ficha 2))
	
	(test (= ?columna0 (- ?columna1 1)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
		
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila 1) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## Evita 3 en raya del usuario horizontal aadiendo ##
; ## una ficha en la izquierda en la fila 1           ##
; ######################################################

(defrule evitar_3enraya_horizontal_usuario_izq_fila1
	

	(declare (salience 37))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila 1) (ficha 0))
	(casilla (columna ?columna1) (fila 1) (ficha 2))
	(casilla (columna ?columna2) (fila 1) (ficha 2))
		
	(test (= ?columna0 (- ?columna1 1)))
	(test (= ?columna2 (+ ?columna1 1)))
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila 1) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; ######################################################
; ## Evita 4 en raya del usuario horizontal por izq   ##
; ## en una fila <> 1                                 ##
; ######################################################
(defrule evitar_4enraya_horizontal_usuario_izq
	

	(declare (salience 42))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila ?fila) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila) (ficha 2))
	(casilla (columna ?columna2) (fila ?fila) (ficha 2))
	(casilla (columna ?columna3) (fila ?fila) (ficha 2))
	(casilla (columna ?columna4) (fila ?fila4) (ficha ?ficha4))

	(test (= ?columna4 (- ?columna1 1)))
	(test (= ?columna0 (- ?columna1 1)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	
	(test (= ?fila (+ ?fila4 1)))

	(test (<> ?ficha4 0))
		
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; ######################################################
; ## Evita 3 en raya del usuario horizontal por izq   ##
; ## en una fila <> 1                                 ##
; ######################################################
(defrule evitar_3enraya_horizontal_usuario_izq
	

	(declare (salience 37))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila ?fila) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila) (ficha 2))
	(casilla (columna ?columna2) (fila ?fila) (ficha 2))
	(casilla (columna ?columna4) (fila ?fila4) (ficha ?ficha4))

	(test (= ?columna4 (- ?columna1 1)))
	(test (= ?columna0 (- ?columna1 1)))
	(test (= ?columna2 (+ ?columna1 1)))
		
	(test (= ?fila (+ ?fila4 1)))

	(test (<> ?ficha4 0))
		
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## Evita 4 en raya del usuario horizontal aadiendo ##
; ## una ficha en la derecha en la fila 1             ##
; ######################################################
(defrule evitar_4enraya_horizontal_usuario_der_fila1
	

	(declare (salience 42))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila 1) (ficha 0))
	(casilla (columna ?columna1) (fila 1) (ficha 2))
	(casilla (columna ?columna2) (fila 1) (ficha 2))
	(casilla (columna ?columna3) (fila 1) (ficha 2))
	
	(test (= ?columna0 (+ ?columna1 3)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila 1) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## Evita 3 en raya del usuario horizontal aadiendo ##
; ## una ficha en la derecha en la fila 1             ##
; ######################################################
(defrule evitar_3enraya_horizontal_usuario_der_fila1
	

	(declare (salience 37))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila 1) (ficha 0))
	(casilla (columna ?columna1) (fila 1) (ficha 2))
	(casilla (columna ?columna2) (fila 1) (ficha 2))
		
	(test (= ?columna0 (+ ?columna1 2)))
	(test (= ?columna2 (+ ?columna1 1)))
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila 1) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## Evita 4 en raya del usuario horizontal por dcha  ##
; ## en una fila <> 1                                 ##
; ######################################################
(defrule evitar_4enraya_horizontal_usuario_der
	

	(declare (salience 42))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila ?fila) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila) (ficha 2))
	(casilla (columna ?columna2) (fila ?fila) (ficha 2))
	(casilla (columna ?columna3) (fila ?fila) (ficha 2))
	(casilla (columna ?columna4) (fila ?fila4) (ficha ?ficha4))	

	(test (= ?columna4 (+ ?columna1 3)))
	(test (= ?columna0 (+ ?columna1 3)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	
	(test (= ?fila (+ ?fila4 1)))

	(test (<> ?ficha4 0))

=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## Evita 3 en raya del usuario horizontal por dcha  ##
; ## en una fila <> 1                                 ##
; ######################################################
(defrule evitar_3enraya_horizontal_usuario_der
	

	(declare (salience 37))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila ?fila) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila) (ficha 2))
	(casilla (columna ?columna2) (fila ?fila) (ficha 2))
	(casilla (columna ?columna4) (fila ?fila4) (ficha ?ficha4))	

	(test (= ?columna4 (+ ?columna1 2)))
	(test (= ?columna0 (+ ?columna1 2)))
	(test (= ?columna2 (+ ?columna1 1)))
		
	(test (= ?fila (+ ?fila4 1)))

	(test (<> ?ficha4 0))

=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; #######################################################
; ##       Evita 4 en raya vertical del usuario        ##
; #######################################################

(defrule evitar_4enraya_vertical
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna) (fila ?fila0) (ficha 0))
	(casilla (columna ?columna) (fila ?fila1) (ficha 2))
	(casilla (columna ?columna) (fila ?fila2) (ficha 2))
	(casilla (columna ?columna) (fila ?fila3) (ficha 2))

	(test (= ?fila2 (+ ?fila1 1)))
	(test (= ?fila3 (+ ?fila1 2)))
	(test (= ?fila0 (+ ?fila1 3)))
			
=>
	(retract ?c)
	(assert (casilla (columna ?columna) (fila ?fila0) (ficha 1)))

	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))	
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)

)
; #######################################################
; ##       Evita 3 en raya vertical del usuario        ##
; #######################################################

(defrule evitar_3enraya_vertical
	
	(declare (salience 35))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna) (fila ?fila0) (ficha 0))
	(casilla (columna ?columna) (fila ?fila1) (ficha 2))
	(casilla (columna ?columna) (fila ?fila2) (ficha 2))
	
	(test (= ?fila2 (+ ?fila1 1)))
	(test (= ?fila0 (+ ?fila1 2)))
			
=>
	(retract ?c)
	(assert (casilla (columna ?columna) (fila ?fila0) (ficha 1)))

	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))	
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)

)
; ###########################################################
; ## Evita 4 en raya diagonal derecha superior del usuairo ##
; ###########################################################

(defrule evitar_4enraya_diagonal_der_sup
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(- ?columna0 3)) (fila =(- ?fila0 3)) (ficha 2))
	(casilla (columna =(- ?columna0 2)) (fila =(- ?fila0 2)) (ficha 2))
	(casilla (columna =(- ?columna0 1)) (fila =(- ?fila0 1)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; ###########################################################
; ## Evita 3 en raya diagonal derecha superior del usuairo ##
; ###########################################################

(defrule evitar_3enraya_diagonal_der_sup
	
	(declare (salience 36))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(- ?columna0 2)) (fila =(- ?fila0 2)) (ficha 2))
	(casilla (columna =(- ?columna0 1)) (fila =(- ?fila0 1)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; ###########################################################
; ## Evita 4 en raya diagonal derecha inferior del usuairo ##
; ###########################################################

(defrule evitar_4enraya_diagonal_der_inf
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(+ ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(+ ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	(casilla (columna =(+ ?columna0 3)) (fila =(+ ?fila0 3)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; #################################################################
; ## Evita 4 en raya diagonal derecha inferior del usuairo fila1 ##
; #################################################################

(defrule evitar_4enraya_diagonal_der_inf_fila1
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(+ ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(+ ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	(casilla (columna =(+ ?columna0 3)) (fila =(+ ?fila0 3)) (ficha 2))
	
	(test (= ?fila0 1))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ###########################################################
; ## Evita 3 en raya diagonal derecha inferior del usuairo ##
; ###########################################################

(defrule evitar_3enraya_diagonal_der_inf
	
	(declare (salience 36))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(+ ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(+ ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; ##################################################################
; ## Evita 3 en raya diagonal derecha inferior del usuairo fila 1 ##
; ##################################################################

(defrule evitar_3enraya_diagonal_der_inf_fila1
	
	(declare (salience 36))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(+ ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(+ ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))

	(test (= ?fila0 1))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ##############################################################
; ##  Evita 4 en raya diagonal izquierda superior del usuairo ##
; ##############################################################
(defrule evitar_4enraya_diagonal_izq_sup
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(+ ?columna0 3)) (fila =(- ?fila0 3)) (ficha 2))
	(casilla (columna =(+ ?columna0 2)) (fila =(- ?fila0 2)) (ficha 2))
	(casilla (columna =(+ ?columna0 1)) (fila =(- ?fila0 1)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ##############################################################
; ##  Evita 3 en raya diagonal izquierda superior del usuairo ##
; ##############################################################
(defrule evitar_3enraya_diagonal_izq_sup
	
	(declare (salience 36))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(+ ?columna0 2)) (fila =(- ?fila0 2)) (ficha 2))
	(casilla (columna =(+ ?columna0 1)) (fila =(- ?fila0 1)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ##############################################################
; ##  Evita 4 en raya diagonal izquierda inferior del usuairo ##
; ##############################################################
(defrule evitar_4enraya_diagonal_izq_inf
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(- ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(- ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	(casilla (columna =(- ?columna0 3)) (fila =(+ ?fila0 3)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; #####################################################################
; ##  Evita 4 en raya diagonal izquierda inferior del usuairo fila 1 ##
; #####################################################################
(defrule evitar_4enraya_diagonal_izq_inf_fila1
	
	(declare (salience 40))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(- ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(- ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	(casilla (columna =(- ?columna0 3)) (fila =(+ ?fila0 3)) (ficha 2))
	
	(test (= ?fila0 1))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; ##############################################################
; ##  Evita 3 en raya diagonal izquierda inferior del usuairo ##
; ##############################################################
(defrule evitar_3enraya_diagonal_izq_inf
	
	(declare (salience 36))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(- ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(- ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	(casilla (columna ?columna0) (fila =(- ?fila0 1)) (ficha ?ficha4))

	(test (<> ?ficha4 0))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)
; #####################################################################
; ##  Evita 3 en raya diagonal izquierda inferior del usuairo fila 1 ##
; #####################################################################
(defrule evitar_3enraya_diagonal_izq_inf_fila1
	
	(declare (salience 36))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna =(- ?columna0 1)) (fila =(+ ?fila0 1)) (ficha 2))
	(casilla (columna =(- ?columna0 2)) (fila =(+ ?fila0 2)) (ficha 2))
	
	(test (= ?fila0 1))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ################################################################################
; ##       	MOVIMIENTOS PARA CONSEGUIR 4 EN RAYA				##
; ################################################################################


; ######################################################
; ##   4 en raya horizontal por izq fila 1            ##
; ######################################################

(defrule 4enraya_horizontal_izq_fila1
	

	(declare (salience 43))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila 1) (ficha 0))
	(casilla (columna ?columna1) (fila 1) (ficha 1))
	(casilla (columna ?columna2) (fila 1) (ficha 1))
	(casilla (columna ?columna3) (fila 1) (ficha 1))
	
	(test (= ?columna0 (- ?columna1 1)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
		
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila 1) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## 		4 en raya horizontal por izq   	      ##
; ######################################################
(defrule 4enraya_horizontal_izq
	

	(declare (salience 43))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila ?fila) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila) (ficha 1))
	(casilla (columna ?columna2) (fila ?fila) (ficha 1))
	(casilla (columna ?columna3) (fila ?fila) (ficha 1))
	(casilla (columna ?columna4) (fila ?fila4) (ficha ?ficha4))

	(test (= ?columna4 (- ?columna1 1)))
	(test (= ?columna0 (- ?columna1 1)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	
	(test (= ?fila (+ ?fila4 1)))

	(test (<> ?ficha4 0))
		
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ## 4 en raya horizontal por derecha en la fila 1    ##
; ######################################################
(defrule 4enraya_horizontal_der_fila1
	

	(declare (salience 43))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila 1) (ficha ?ficha0))
	(casilla (columna ?columna1) (fila 1) (ficha 1))
	(casilla (columna ?columna2) (fila 1) (ficha 1))
	(casilla (columna ?columna3) (fila 1) (ficha 1))
	
	(test (= ?columna0 (+ ?columna1 3)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila 1) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ######################################################
; ##      4 en raya horizontal por dcha  	      ##
; ######################################################
(defrule 4enraya_horizontal_der
	

	(declare (salience 43))
	?t <- (turno (es 1))
	
	?c <- (casilla (columna ?columna0) (fila ?fila) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila) (ficha 1))
	(casilla (columna ?columna2) (fila ?fila) (ficha 1))
	(casilla (columna ?columna3) (fila ?fila) (ficha 1))
	(casilla (columna ?columna4) (fila ?fila4) (ficha ?ficha4))	

	(test (= ?columna4 (+ ?columna1 3)))
	(test (= ?columna0 (+ ?columna1 3)))
	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	
	(test (= ?fila (+ ?fila4 1)))

	(test (<> ?ficha4 0))

=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ####################################################
; ##       4 en raya vertical 			    ##
; ####################################################
(defrule 4enraya_vertical
	
	(declare (salience 43))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna) (fila ?fila0) (ficha 0))
	(casilla (columna ?columna) (fila ?fila1) (ficha 1))
	(casilla (columna ?columna) (fila ?fila2) (ficha 1))
	(casilla (columna ?columna) (fila ?fila3) (ficha 1))

	(test (= ?fila2 (+ ?fila1 1)))
	(test (= ?fila3 (+ ?fila1 2)))
	(test (= ?fila0 (+ ?fila1 3)))
			
=>
	(retract ?c)
	(assert (casilla (columna ?columna) (fila ?fila0) (ficha 1)))

	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))	
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)

)

; ###################################################
; ##     4 en raya diagonal superior derecha       ##
; ###################################################
(defrule diagonal_der_sup
	
	(declare (salience 43))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila1) (ficha 1))
	(casilla (columna ?columna2) (fila ?fila2) (ficha 1))
	(casilla (columna ?columna3) (fila ?fila3) (ficha 1))
	(casilla (columna ?columna0) (fila ?fila3) (ficha ?ficha4))

	(test (= ?columna2 (+ ?columna1 1)))
	(test (= ?columna3 (+ ?columna1 2)))
	(test (= ?columna0 (+ ?columna1 3)))

	(test (= ?fila2 (+ ?fila1 1)))
	(test (= ?fila3 (+ ?fila1 2)))
	(test (= ?fila0 (+ ?fila1 3)))
	
	(test (<> ?ficha4 0))
	
=>
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ####################################################
; ##         4 en raya diagonal superior izquierda  ##
; ####################################################

(defrule diagonal_izq_sup
	
	(declare (salience 43))
	
	?t <- (turno (es 1))

	?c <- (casilla (columna ?columna0) (fila ?fila0) (ficha 0))
	(casilla (columna ?columna1) (fila ?fila1) (ficha 1))
	(casilla (columna ?columna2) (fila ?fila2) (ficha 1))
	(casilla (columna ?columna3) (fila ?fila3) (ficha 1))
	(casilla (columna ?columna0) (fila ?fila3) (ficha ?ficha4))

	(test (= ?columna2 (- ?columna1 1)))
	(test (= ?columna3 (- ?columna1 2)))
	(test (= ?columna0 (- ?columna1 3)))

	(test (= ?fila2 (+ ?fila1 1)))
	(test (= ?fila3 (+ ?fila1 2)))
	(test (= ?fila0 (+ ?fila1 3)))
	
	(test (<> ?ficha4 0))

=> 
	(retract ?c)
	(assert (casilla (columna ?columna0) (fila ?fila0) (ficha 1)))
	
	(retract ?t)
	(assert (turno (es 2)))

	(assert (mostrar 1))
	(printout t crlf "   EL mueve a la columna " ?columna0  crlf)
)

; ####################################################
; ##       Elegir nmero de columna aleatorio	    ##
; ####################################################
(defrule columna_aleatoria

	(declare (salience 10))
	(turno (es 1))
	?c <- (columna ?columna)
	?l <- (leido_columna ?)
	
=>
	(retract ?c)
	(assert (columna (+ 1 (mod (random) 7))))
	(retract ?l)
	(assert (leido_columna 1))
)

; ###################################################
; ##      Movimiento de la mquina si el nmero    ##
; ##      aleatorio elegido es vlido 		   ##
; ###################################################

(defrule movimiento_maquina_1
	
	(declare (salience 24))
	?t <-(turno (es 1))
	
	?l <- (leido_columna 1)
	
	?c <- (columna ?columna)

	?cas1 <- (casilla (columna ?columna) (fila 1) (ficha 0))
=>

	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))

	(retract ?cas1)
	(assert (casilla (columna ?columna) (fila 1) (ficha 1)))
	
	(assert (mostrar 1))
	(retract ?t)
	(assert (turno (es 2)))
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)
)

(defrule movimiento_maquina_2
	
	(declare (salience 23))
	?t <-(turno (es 1))
	
	?l <- (leido_columna 1)
	
	?c <- (columna ?columna)

	?cas2 <- (casilla (columna ?columna) (fila 2) (ficha 0))
	
=>

	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))

	(retract ?cas2)
	(assert (casilla (columna ?columna) (fila 2) (ficha 1)))
	
	(assert (mostrar 1))
	(retract ?t)
	(assert (turno (es 2)))
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)
)

(defrule movimiento_maquina_3
	
	(declare (salience 22))
	?t <-(turno (es 1))
	
	?l <- (leido_columna 1)
	
	?c <- (columna ?columna)

	?cas3 <- (casilla (columna ?columna) (fila 3) (ficha 0))
	
=>

	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))

	(retract ?cas3)
	(assert (casilla (columna ?columna) (fila 3) (ficha 1)))
	
	(assert (mostrar 1))
	(retract ?t)
	(assert (turno (es 2)))
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)
)

(defrule movimiento_maquina_4
	
	(declare (salience 21))
	?t <-(turno (es 1))
	
	?l <- (leido_columna 1)
	
	?c <- (columna ?columna)

	?cas4 <- (casilla (columna ?columna) (fila 4) (ficha 0))
=>

	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))

	(retract ?cas4)
	(assert (casilla (columna ?columna) (fila 4) (ficha 1)))
	
	(assert (mostrar 1))
	(retract ?t)
	(assert (turno (es 2)))
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)
)

(defrule movimiento_maquina_5
	
	(declare (salience 20))
	?t <-(turno (es 1))
	
	?l <- (leido_columna 1)
	
	?c <- (columna ?columna)

	?cas5 <- (casilla (columna ?columna) (fila 5) (ficha 0))
=>

	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))

	(retract ?cas5)
	(assert (casilla (columna ?columna) (fila 5) (ficha 1)))
	
	(assert (mostrar 1))
	(retract ?t)
	(assert (turno (es 2)))
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)
)

(defrule movimiento_maquina_6
	
	(declare (salience 19))
	?t <-(turno (es 1))
	
	?l <- (leido_columna 1)
	
	?c <- (columna ?columna)

	?cas6 <- (casilla (columna ?columna) (fila 6) (ficha 0))
=>

	(retract ?l)
	(retract ?c)
	(assert (leido_columna 0))
	(assert (columna 0))

	(retract ?cas6)
	(assert (casilla (columna ?columna) (fila 6) (ficha 1)))
	
	(assert (mostrar 1))
	(retract ?t)
	(assert (turno (es 2)))
	(printout t crlf "   EL mueve a la columna " ?columna  crlf)
)

; #####################################################################
; ###           COMPROBAR FINAL DE PARTIDA                           ##
; #####################################################################

(defrule casillas_completas 
	(declare (salience 45))	

	(casilla (columna 1) (fila 6) (ficha ?ficha1))
	(casilla (columna 2) (fila 6) (ficha ?ficha2))
	(casilla (columna 3) (fila 6) (ficha ?ficha3))
	(casilla (columna 4) (fila 6) (ficha ?ficha4))
	(casilla (columna 5) (fila 6) (ficha ?ficha5))
	(casilla (columna 6) (fila 6) (ficha ?ficha6))

	(test (<> ?ficha1 0))
	(test (<> ?ficha2 0))
	(test (<> ?ficha3 0))
	(test (<> ?ficha4 0))
	(test (<> ?ficha5 0))
	(test (<> ?ficha6 0))

=>
	(printout t "        QUEDAMOS EMPATADOS" crlf)
	(printout t "ESTN TODAS LAS CASILLAS OCUPADAS" crlf)
	(halt)
)

; #####################################################
; ## 		GANA LA PARTIDA LA MQUINA           ##
; #####################################################
(defrule horizontal_maquina
	(declare (salience 45))
	
	(casilla (columna ?columna1) (fila ?fila) (ficha 1))
	(casilla (columna =(+ ?columna1 1)) (fila ?fila) (ficha 1))
	(casilla (columna =(+ ?columna1 2)) (fila ?fila) (ficha 1))
	(casilla (columna =(+ ?columna1 3)) (fila ?fila) (ficha 1))

=> 
	(printout t crlf "HAS PERDIDO ..." crlf)
	(halt)
)

(defrule vertical_maquina
	(declare (salience 45))
	
	(casilla (columna ?columna) (fila ?fila1) (ficha 1))
	(casilla (columna ?columna) (fila =(+ ?fila1 1)) (ficha 1))
	(casilla (columna ?columna) (fila =(+ ?fila1 2)) (ficha 1))
	(casilla (columna ?columna) (fila =(+ ?fila1 3)) (ficha 1))

=>
	(printout t crlf "HAS PERDIDO ..." crlf)
	(halt)
)

(defrule diagonal_der_sup_maquina
	(declare (salience 45))
	
	(casilla (columna ?columna) (fila ?fila) (ficha 1))
	(casilla (columna =(+ ?columna 1)) (fila =(+ ?fila 1)) (ficha 1))
	(casilla (columna =(+ ?columna 2)) (fila =(+ ?fila 2)) (ficha 1))
	(casilla (columna =(+ ?columna 3)) (fila =(+ ?fila 3)) (ficha 1))

=> 
	(printout t crlf "HAS PERDIDO ..." crlf)
	(halt)
z)

(defrule diagonal_izq_sup_maquina
	(declare (salience 45))
	
	(casilla (columna ?columna) (fila ?fila) (ficha 1))
	(casilla (columna =(- ?columna 1)) (fila =(+ ?fila 1)) (ficha 1))
	(casilla (columna =(- ?columna 2)) (fila =(+ ?fila 2)) (ficha 1))
	(casilla (columna =(- ?columna 3)) (fila =(+ ?fila 3)) (ficha 1))

=>
	(printout t crlf "HAS PERDIDO ..." crlf)
	(halt)

)

; #####################################################
; ## 		GANA LA PARTIDA EL USUARIO           ##
; #####################################################
(defrule horizontal_usuario
	(declare (salience 45))
	
	(casilla (columna ?columna1) (fila ?fila) (ficha 2))
	(casilla (columna =(+ ?columna1 1)) (fila ?fila) (ficha 2))
	(casilla (columna =(+ ?columna1 2)) (fila ?fila) (ficha 2))
	(casilla (columna =(+ ?columna1 3)) (fila ?fila) (ficha 2))

=> 
	(assert (mostrar 1))
	(assert (usuario gana))
)

(defrule vertical_usuario
	(declare (salience 45))
	
	(casilla (columna ?columna) (fila ?fila1) (ficha 2))
	(casilla (columna ?columna) (fila =(+ ?fila1 1)) (ficha 2))
	(casilla (columna ?columna) (fila =(+ ?fila1 2)) (ficha 2))
	(casilla (columna ?columna) (fila =(+ ?fila1 3)) (ficha 2))

=>
	(assert (mostrar 1))
	(assert (usuario gana))
)

(defrule diagonal_der_sup_usuario
	(declare (salience 45))
	
	(casilla (columna ?columna) (fila ?fila) (ficha 2))
	(casilla (columna =(+ ?columna 1)) (fila =(+ ?fila 1)) (ficha 2))
	(casilla (columna =(+ ?columna 2)) (fila =(+ ?fila 2)) (ficha 2))
	(casilla (columna =(+ ?columna 3)) (fila =(+ ?fila 3)) (ficha 2))

=> 
	(assert (mostrar 1))
	(assert (usuario gana))
)

(defrule diagonal_izq_sup_usuario
	(declare (salience 45))
	
	(casilla (columna ?columna) (fila ?fila) (ficha 2))
	(casilla (columna =(- ?columna 1)) (fila =(+ ?fila 1)) (ficha 2))
	(casilla (columna =(- ?columna 2)) (fila =(+ ?fila 2)) (ficha 2))
	(casilla (columna =(- ?columna 3)) (fila =(+ ?fila 3)) (ficha 2))

=>
	(assert (mostrar 1))
	(assert (usuario gana))
)

(defrule usuario_gana

	(declare (salience 48))
	(usuario gana)
=>
	(printout t crlf "HAS GANADO ..." crlf)
	(halt)
)

; ######################################
; ## Mostrar tablero                  ##
; ######################################
(defrule mostrar_tablero
	(declare (salience 50))
	?m <- (mostrar 1)	
	(casilla (columna 1) (fila 1) (ficha ?ficha11))
	(casilla (columna 1) (fila 2) (ficha ?ficha12))
	(casilla (columna 1) (fila 3) (ficha ?ficha13))
	(casilla (columna 1) (fila 4) (ficha ?ficha14))
	(casilla (columna 1) (fila 5) (ficha ?ficha15))
	(casilla (columna 1) (fila 6) (ficha ?ficha16))
	(casilla (columna 2) (fila 1) (ficha ?ficha21))
	(casilla (columna 2) (fila 2) (ficha ?ficha22))
	(casilla (columna 2) (fila 3) (ficha ?ficha23))
	(casilla (columna 2) (fila 4) (ficha ?ficha24))
	(casilla (columna 2) (fila 5) (ficha ?ficha25))
	(casilla (columna 2) (fila 6) (ficha ?ficha26))
	(casilla (columna 3) (fila 1) (ficha ?ficha31))
	(casilla (columna 3) (fila 2) (ficha ?ficha32))
	(casilla (columna 3) (fila 3) (ficha ?ficha33))
	(casilla (columna 3) (fila 4) (ficha ?ficha34))
	(casilla (columna 3) (fila 5) (ficha ?ficha35))
	(casilla (columna 3) (fila 6) (ficha ?ficha36))
	(casilla (columna 4) (fila 1) (ficha ?ficha41))
	(casilla (columna 4) (fila 2) (ficha ?ficha42))
	(casilla (columna 4) (fila 3) (ficha ?ficha43))
	(casilla (columna 4) (fila 4) (ficha ?ficha44))
	(casilla (columna 4) (fila 5) (ficha ?ficha45))
	(casilla (columna 4) (fila 6) (ficha ?ficha46))
	(casilla (columna 5) (fila 1) (ficha ?ficha51))
	(casilla (columna 5) (fila 2) (ficha ?ficha52))
	(casilla (columna 5) (fila 3) (ficha ?ficha53))
	(casilla (columna 5) (fila 4) (ficha ?ficha54))
	(casilla (columna 5) (fila 5) (ficha ?ficha55))
	(casilla (columna 5) (fila 6) (ficha ?ficha56))
	(casilla (columna 6) (fila 1) (ficha ?ficha61))
	(casilla (columna 6) (fila 2) (ficha ?ficha62))
	(casilla (columna 6) (fila 3) (ficha ?ficha63))
	(casilla (columna 6) (fila 4) (ficha ?ficha64))
	(casilla (columna 6) (fila 5) (ficha ?ficha65))
	(casilla (columna 6) (fila 6) (ficha ?ficha66))
	(casilla (columna 7) (fila 1) (ficha ?ficha71))
	(casilla (columna 7) (fila 2) (ficha ?ficha72))
	(casilla (columna 7) (fila 3) (ficha ?ficha73))
	(casilla (columna 7) (fila 4) (ficha ?ficha74))
	(casilla (columna 7) (fila 5) (ficha ?ficha75))
	(casilla (columna 7) (fila 6) (ficha ?ficha76))
=>
	(printout t crlf "             ESTADO DEL TABLERO " crlf)
	(printout t "             ================== " crlf)
	(printout t "            1  2  3  4  5  6  7" crlf)
	(printout t "         _________________________" crlf)
	(printout t "         |                       |" crlf)
	(printout t "         |  " ?ficha16 "  " ?ficha26 "  " ?ficha36 "  " ?ficha46 "  " ?ficha56 "  " ?ficha66 "  " ?ficha76 "  |" crlf)
	(printout t "         |                       |" crlf)
	(printout t "         |  " ?ficha15 "  " ?ficha25 "  " ?ficha35 "  " ?ficha45 "  " ?ficha55 "  " ?ficha65 "  " ?ficha75 "  |" crlf)
	(printout t "         |                       |" crlf)
	(printout t "         |  " ?ficha14 "  " ?ficha24 "  " ?ficha34 "  " ?ficha44 "  " ?ficha54 "  " ?ficha64 "  " ?ficha74 "  |" crlf)
	(printout t "         |                       |" crlf)
	(printout t "         |  " ?ficha13 "  " ?ficha23 "  " ?ficha33 "  " ?ficha43 "  " ?ficha53 "  " ?ficha63 "  " ?ficha73 "  |" crlf)
	(printout t "         |                       |" crlf)
	(printout t "         |  " ?ficha12 "  " ?ficha22 "  " ?ficha32 "  " ?ficha42 "  " ?ficha52 "  " ?ficha62 "  " ?ficha72 "  |" crlf)
	(printout t "         |                       |" crlf)
	(printout t "         |  " ?ficha11 "  " ?ficha21 "  " ?ficha31 "  " ?ficha41 "  " ?ficha51 "  " ?ficha61 "  " ?ficha71 "  |" crlf)
	(printout t "         -------------------------" crlf)
	(retract ?m)
)
